if not Recount then return end

local Recount = Recount

local RecountPotions = LibStub("AceAddon-3.0"):NewAddon("RecountPotions", "AceEvent-3.0")

local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")

local trackedPotions = {
-- Classic
	438,	-- Restore Mana (Lesser Mana Potion)
-- Burning Crusade
	28494,	-- Insane Strength Potion
	38929,	-- Fel mana potion
-- Wrath of Lich King
	43185,	-- Healing Potion
	43186,	-- Restore Mana (Runic Mana Potion)
	53750,	-- Crazy Alchemist's Potion
	53753,	-- Nightmare Slumber
	53761,	-- Powerful Rejuvenation Potion
	53762,	-- Indestructible
	53908,	-- Potion of Speed
	53909,	-- Potion of Wild Magic
	53910,	-- Arcane Protection
	53911,	-- Fire Protection 
	53913,	-- Frost Protection
	53914,	-- Nature Protection
	53915,	-- Shadow Protection
	67490,	-- Runic Mana Injector
-- Cataclysm
	75487,	-- Potion of Pure Genius
	75488,	-- Potion of Ogre Rage
	75489,	-- Potion of the Cobra
	78778,	-- Mysterious Potion
	78989,	-- Mythical Healing Potion
	78990,	-- Restore Mana (Mythical Mana Potion)
	78993,	-- Potion of Concentration
	79475,	-- Earthen Potion
	79476,	-- Volcanic Potion
	79633,	-- Potion of the Tol'vir
	79634,	-- Golemblood Potion
-- Mists of Pandaria
	105697, -- Virmen's Bite
	105698, -- Potion of the Mountains
	105701, -- Potion of Focus
	105702, -- Potion of the Jade Serpent
	105704, -- Alchemist's Rejuvenation
	105706, -- Potion of Mogu Power
	105708, -- Master Health Potion
	105709, -- Restore Mana (Master Mana Potion)
	130649, -- Life Spirit
	130650, -- Water Spirit
}

local customSpellName = {
	[438] 		= "Lesser Mana Potion",
	[43186]		= "Runic Mana Potion",
	[78990]		= "Mythical Mana Potion",
	[105709]	= "Master Mana Potion",
}

local DetailTitles={}
DetailTitles.WhatPotion={
	TopNames = "Potions",
	TopCount = "",
	TopAmount = "Potions",
	BotNames = "Potions",
	BotMin = "",
	BotAvg = "",
	BotMax = "",
	BotAmount = "Count"
}

function RecountPotions:OnInitialize()
end

function RecountPotions:OnEnable()
	if not Recount then return end
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function RecountPotions:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function RecountPotions:COMBAT_LOG_EVENT_UNFILTERED(event, ...)
	local timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags
	local spellID, spellname, spellSchool
	
	timestamp, eventType, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = select(1, ...)
	spellID, spellname, spellSchool = select(12, ...)
	
	if not Recount.db.profile.GlobalDataCollect or not Recount.CurrentDataCollect then
		return
	end
	
	if not Recount:CheckRetentionFromFlags(sourceFlags) and not Recount:CheckRetentionFromFlags(destFlags) then
		return
	end
	
	if (sourceName == nil) then
		sourceName = "No One"
	else
		Recount:MatchGUID(sourceName, sourceGUID, sourceFlags)
	end
	
	if (destName == nil) then
		destName = "No One"
	else
		Recount:MatchGUID(destName, destGUID, destFlags)
	end
	
	if (eventType == "SPELL_CAST_SUCCESS") then
		local i, usedPotion, sourceData, srcName, spell
	
		for i, usedPotion in ipairs(trackedPotions) do
			if usedPotion == spellID then
				if not Recount.db2.combatants[sourceName] then
					Recount:DPrint("No source combatant!")
				else
					sourceData=Recount.db2.combatants[sourceName]
					srcName = sourceData.Name
					Recount:AddAmount(sourceData, "Potions", 1)
					spell = GetSpellInfo(spellID) or ""
					if (customSpellName[spellID]) then spell = customSpellName[spellID] end
					Recount:AddTableDataStats(sourceData, "WhatPotion", spell, srcName, 1)
				end
			end
		end
	end
end

function RecountPotions:DataModesPotions(data, num)
    if not data then return 0 end
    if num==1 then
        return (data.Fights[Recount.db.profile.CurDataSet].Potions or 0)
    else
        return (data.Fights[Recount.db.profile.CurDataSet].Potions or 0), {{data.Fights[Recount.db.profile.CurDataSet].WhatPotion, "'s Potions", DetailTitles.WhatPotion}}
    end
end

function RecountPotions:TooltipFuncsPotions(name, data)
    local SortedData,total
    GameTooltip:ClearLines()
    GameTooltip:AddLine(name)
    Recount:AddSortedTooltipData(RL["Top 3"].." Potions",data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].WhatPotion,3)
    GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip("Potions",RecountPotions.DataModesPotions,RecountPotions.TooltipFuncsPotions,nil,nil,nil,nil)